
<!doctype html>
<html lang="en">
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no, user-scalable=no">
		<meta name="apple-mobile-web-app-capable" content="yes" />
		<meta name="description" content="">
		<meta name="author" content="">

		<link rel="apple-touch-icon" sizes="180x180" href="static/apple-touch-icon.png">
		<link rel="icon" type="image/png" sizes="32x32" href="static/favicon-32x32.png">
		<link rel="icon" type="image/png" sizes="16x16" href="static/favicon-16x16.png">
		<link rel="manifest" href="static/site.webmanifest">
		<link rel="mask-icon" href="static/safari-pinned-tab.svg" color="#5bbad5">
		<meta name="msapplication-TileColor" content="#da532c">
		<meta name="theme-color" content="#666666">

		<title>Ultrasonic manipulation platform</title>

		<!-- Bootstrap core CSS -->
		<link href="/static/css/bootstrap.min.css" rel="stylesheet">
		<link rel="stylesheet" href="/static/css/all.css">
		<!-- Custom styles for this template -->
	</head>

	<body>
		{% set colors = ("ff0000", "0000ff", "ffff00") %}
		{% set width = 28 %}
		{% set height = 36 %}
		<div class"container-fluid">
			<div class="" style="position:absolute;">
				<button type="button" class="btn btn-lg btn-primary" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false"><i class="fas fa-bars" style="font-size:5vw"></i></button>
				<div class="dropdown-menu">
					<span>Platform modes</span>
					<a class="dropdown-item mode-switch" href="/balls">Balls</a>
					<a class="dropdown-item {% if num_obj==2 %}active{% endif %} mode-switch" href="/triangle2">Two Triangles</a>
					<a class="dropdown-item {% if num_obj==3 %}active{% endif %} mode-switch" href="/triangle3">Three Triangles</a>
					<a class="dropdown-item mode-switch" href="/">Deactivate platform</a>
					<div class="dropdown-divider"></div>
					<button type="button" class="dropdown-item demo-toggle">Demo</button>
					<div class="dropdown-divider"></div>
					<span>Computer vision</span><br>
					<div class="btn-group service-switch" role="group" data-service="vision" aria-label="Basic example">
						<button type="button" class="btn btn-success" data-command="start">Start</button>
						<button type="button" class="btn btn-danger" data-command="stop">Stop</button>
						<button type="button" class="btn btn-primary" data-command="restart">Restart</button>
						<button type="button" class="btn btn-secondary" data-command="status">Status</button>
					</div>
					<span>Current detector: <b id="detector"></b></span>
					<button type="button" class="btn btn-success load-detector" style="display:none">Load the correct detector</button>
					<span id="msg-start-detector" style="display:none">Check the service status and press the Start or Restart button</span>
					<div class="dropdown-divider"></div>
					<span><i>Balls</i> service (make sure that this service is <b>not</b> running)</span><br>
					<div class="btn-group service-switch" role="group" data-service="RGBballs" aria-label="Basic example">
						<button type="button" class="btn btn-success" data-command="start">Start</button>
						<button type="button" class="btn btn-danger" data-command="stop">Stop</button>
						<button type="button" class="btn btn-primary" data-command="restart">Restart</button>
						<button type="button" class="btn btn-secondary" data-command="status">Status</button>
					</div>
					<span><i>2 Triangles</i> service (make sure that this service {% if num_obj==2 %}<b>is</b>{% else %}is <b>not</b>{% endif %} running)</span><br>
					<div class="btn-group service-switch" role="group" data-service="triangles2" aria-label="Basic example">
						<button type="button" class="btn btn-success" data-command="start">Start</button>
						<button type="button" class="btn btn-danger" data-command="stop">Stop</button>
						<button type="button" class="btn btn-primary" data-command="restart">Restart</button>
						<button type="button" class="btn btn-secondary" data-command="status">Status</button>
					</div>
					<span><i>3 Triangles</i> service (make sure that this service {% if num_obj==3 %}<b>is</b>{% else %}is <b>not</b>{% endif %} running)</span><br>
					<div class="btn-group service-switch" role="group" data-service="triangles3" aria-label="Basic example">
						<button type="button" class="btn btn-success" data-command="start">Start</button>
						<button type="button" class="btn btn-danger" data-command="stop">Stop</button>
						<button type="button" class="btn btn-primary" data-command="restart">Restart</button>
						<button type="button" class="btn btn-secondary" data-command="status">Status</button>
					</div>
					<div class="dropdown-divider"></div>
					<span>Utility</span>
					<a class="dropdown-item btn-secondary" href="calib/0" id="calib">Calibration</a>
					<button type="button" class="dropdown-item btn-primary" id="reboot">Reboot</button>
					<button type="button" class="dropdown-item btn-danger" id="poweroff">Poweroff</button>
				</div>
			</div>
			<div class="imgbox">
				<svg id="svg" style="width:98vw;height:98vh" viewBox="0 0 250 250" xmlns="http://www.w3.org/2000/svg">
					<defs>
						<radialGradient id="grad1" cx="50%" cy="50%" r="80%" fx="40%" fy="40%">
							<stop offset="0%" style="stop-color:rgb(255,255,255);stop-opacity:0" />
							<stop offset="100%" style="stop-color:rgb(0,0,0);stop-opacity:1" />
						</radialGradient>
					</defs>

					<rect width="250" height="250" style="fill:#D0D0FF;stroke:#000000;stroke-width:2;stroke-opacity:1" />
					<g id="plate" transform="translate(25,25)">
						<rect width="200" height="200" style="fill:#444444;stroke:#000000;stroke-width:0.2;stroke-opacity:1" />
						{% for index in range(num_obj) %}
						<g class="triangle" id="triangle" data-index="{{index}}" data-color="{{colors[index]}}" transform="translate(0,25)">
							<polygon points="{{0-height/3}},{{width/2}} {{0-height/3}},{{0-width/2}} {{2*height/3}},0" fill="#{{colors[index]}}" style="stroke:#000000;stroke-width:0.4"/>
						</g>
						<g id="ref{{index}}" class="ref" data-index="{{index}}" data-color="{{colors[index]}}" transform="translate(0,0)">
							<polygon points="{{0-height/3}},{{width/2}} {{0-height/3}},{{0-width/2}} {{2*height/3}},0" style="fill:#{{colors[index]}};fill-opacity:0.3;stroke:#000000;stroke-width:0.4;stroke-dasharray:2,2"/>
							<g class="ref_circle" id="ref_center" data-index="{{index}}" data-type="center">
								<circle cx="0" cy="0" r="{{height/3}}" style="fill:white;fill-opacity:0.0;stroke:#000000;stroke-width:0.0"/>
							</g>
							<g class="ref_circle" id="ref_end" data-index="{{index}}" data-type="end">
								<circle cx="{{2*height/3}}" cy="0" r="{{height/3}}" style="fill:white;fill-opacity:0.0;stroke:#000000;stroke-width:0.0"/>
							</g>
						</g>
						{% endfor %}
					</g>
					<text id="debug" x="50" y="15" fill="black"></text>
				</svg>
			</div>

			<!-- Modal -->
			<div class="modal fade" id="statusModal" tabindex="-1" role="dialog" aria-labelledby="statusModalLabel" aria-hidden="true">
			  <div class="modal-dialog" role="document">
			    <div class="modal-content">
			      <div class="modal-header">
			        <h5 class="modal-title" id="statusModalLabel">Service status</h5>
			        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
			          <span aria-hidden="true">&times;</span>
			        </button>
			      </div>
			      <div class="modal-body">
			        <pre>
			        </pre>
			      </div>
			      <div class="modal-footer">
			        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
			      </div>
			    </div>
			  </div>
			</div>
		</div>


		<!-- Bootstrap core JavaScript
		================================================== -->
		<!-- Placed at the end of the document so the pages load faster -->
		<!--<script src="https://code.jquery.com/jquery-3.3.1.min.js" crossorigin="anonymous"></script>
		<script>window.jQuery || document.write('<script src="/static/js/jquery-3.3.1.min.js"><\/script>')</script>-->
		<script src="/static/js/jquery-3.3.1.min.js"></script>
		<script src="/static/js/bootstrap.bundle.min.js"></script>
		<script type="text/javascript" src="/static/js/socket.io.min.js"></script>
		<script>
			var pt = $("svg")[0].createSVGPoint();  // Created once for document
			const area_size = {{ area_size}}; // size of the manipulation area
			const num_obj = {{ num_obj }}
			var selected_ref = null;
			var demo = 0;
			
			function select_ref(ev){
				selected_ref = $(this);
			}

			function deselect_ref(ev){
				selected_ref = null;
			}			

			function move(x,y) {
				pt.x = x;
				pt.y = y;

				// The cursor point, translated into svg coordinates
				var cursorpt =  pt.matrixTransform($("#plate")[0].getScreenCTM().inverse());
				x = cursorpt.x;
				y = cursorpt.y;

				if(selected_ref != null){
					if (y<0) {
						y = 0;
					} else if (y>200) {
						y = 200;
					}
					if (x<0) {
						x = 0;
					} else if (x>200) {
						x = 200;
					}

					index = selected_ref.data('index');
					x = (100-x)*area_size/200;
					y = (100-y)*area_size/200;
					pos = [x,y]
					
					//socket.emit('reference', index, pos)
					if (selected_ref.data("type") == "center") {
						socket.emit("reference_center", index, pos);
					} else {
						socket.emit("reference_end", index, pos);
					}
				}
			}

			$(function(){
				$(".triangle,.ref").on("move", function(evt, x, y, rot){
					$(this).attr("transform", "translate(" + x + "," + y + "),rotate(" + rot + ")")
				})

				// if(window.DeviceMotionEvent){
				// 	window.addEventListener("devicemotion", motion, false);
				// }else{
				// 	console.log("DeviceMotionEvent is not supported");
				// }

				$(".ref_circle").on('touchstart', select_ref)
				$(".ref_circle").mousedown(select_ref);
				$("svg").mouseup(deselect_ref)
				$("svg").on('touchend', deselect_ref)
				$("svg").on('mousemove', function(event){
					_this = $(this)
					event.preventDefault();
					var e = event.originalEvent;
					move(event.clientX, event.clientY);
					if(selected_ref != null) console.log('Mouse move')
				})
				$("svg").bind("touchmove", function (event) {
					_this = $(this)
					event.preventDefault();
					x = event.originalEvent.targetTouches[0].clientX;
					y = event.originalEvent.targetTouches[0].clientY;
					move(x, y);
					if(selected_ref != null) console.log('Touch move')
				});
			})

			var socket = io.connect('http://' + document.domain + ':' + location.port);

			socket.emit('request_update')

			socket.on('connect', function() {
				//$(".mode-selector[data-mode="+mode+"]").addClass("active")
			});

			/*socket.on('wait_message', function () {
				$("#text_wait").attr("visibility","visible")
				if (mode == 0) $("#text_default").attr("visibility","hidden")
			})*/

			/*socket.on('lock', function(override) {
				if (!ref_selected && !gauge_selected || override) {
					control_locked = true
				}
			})*/

			/*socket.on('unlock', function() {
				control_locked = false
			})*/

			socket.on('refresh', function(){
				location.reload()
			});

			var last = 0;

			socket.on('update', function(data){
				pos = data.position;
				ref = data.reference;

				$('.triangle').each(function (i, obj) {
					posi = pos[i];
					x = - posi[0]*200/area_size + 100;
					y = - posi[1]*200/area_size + 100;
					rot = posi[2]* 57.2957795 + 180;
					$(this).trigger("move", [x,y,rot])
				})

				$('.ref').each(function (i, obj) {
					refi = ref[i];
					x = - refi[0]*200/area_size + 100;
					y = - refi[1]*200/area_size + 100;
					rot = refi[2] * 57.2957795 + 180;
					$(this).trigger("move", [x,y,rot])
				})			

				now = new Date().valueOf()
				diff = now - last
				//console.log((1000/diff))
				last = now
			})

			setInterval(function () { socket.emit("get_detector"); }, 1000);

			socket.on("detector", function (name) {
				detector_text = $("#detector")[0];
				detector_button = $(".load-detector")[0];
				detector_text.innerHTML = name;
				service_message = $("#msg-start-detector")[0];
				if (name.toLowerCase() == "triangle") {
					detector_text.style.color = "green";
					detector_button.style.display = 'none';
					service_message.style.display = 'none';
				} else if (name.toLowerCase() == "service offline") {
					detector_text.style.color = "red";
					detector_button.style.display = 'none';
					service_message.style.display = 'initial';
				} else {
					detector_text.style.color = "red";
					detector_button.style.display = 'initial';
					service_message.style.display = 'none';
				}
			})

			$(function () {
					$(".service-switch button").click(function (){
						_this = $(this)
						command = _this.data("command")
						service = _this.parent().data("service")
						console.log(command, service)
						$.get( service+"/"+command, function( data ) {
						  if(data != ""){
						  	$('#statusModal pre').text(data)
						  	$('#statusModal').modal()

						  }
						});
					})

					$(".demo-toggle").click(function () {
						if (demo == 0) {
							demo = 1;
							$(".demo-toggle").addClass("active")
						} else {
							demo = 0;
							$(".demo-toggle").removeClass("active")
						}
						socket.emit("set_demo", demo)
					})

					$(".load-detector").click(function () {
						socket.emit("change_detector", "/home/pi/config_triangle.json")
					})

					$("#poweroff").click(function (){
						$.get("poweroff");
					})

					$("#reboot").click(function (){
						$.get("reboot");
					})
			});
		</script>

		<script src="/static/js/d3.v3.min.js"></script>
		<script>

		var color = d3.scale.category10();

		var svg = d3.select("svg")

		var circle = svg.selectAll("circle.touch");

		d3.select("#plate")
		    .on("touchstart", touch)
		    .on("touchmove", touch)
		    .on("touchend", touch);

		function touch() {
		  d3.event.preventDefault();
		  //console.log(d3.touches(svg.node()))
		  _this = $(this)
		  socket.emit('touches', d3.touches(svg.node()));
		}

		// function touch() {
		//   d3.event.preventDefault();

		//   circle = circle
		//       .data(d3.touches(svg.node()), function(d) { return d.identifier; });

		//   circle.exit()
		//       .attr("class", null)
		//     .transition()
		//       .attr("r", 1e-6)
		//       .remove();

		//   circle.enter().append("circle")
		//       .attr("class", "touch")
		//       .attr("r", 1e-6)
		//       .style("fill", function(d) { return color(d.identifier); })
		//     .transition()
		//       .duration(500)
		//       .ease("elastic")
		//       .attr("r", 48);

		//   circle
		//       .attr("cx", function(d) { return d[0]; })
		//       .attr("cy", function(d) { return d[1]; });
		// }
		</script>
	</body>
</html>
